default:
  image: docker:24.0.5
  services:
    - docker:24.0.5-dind
  before_script:
    - until docker info; do sleep 1; done
    - echo $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA $PWD
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY

variables:
  VERSION: 1.0.0
  DOCKER_HOST: tcp://docker:2376
  DOCKER_TLS_VERIFY: 1
  DOCKER_TLS_CERTDIR: "/certs"
  DOCKER_CERT_PATH: "$DOCKER_TLS_CERTDIR/client"

stages:
  - build

arm64:
  stage: build
  tags:
    - "[arm64]"
  only:
    - main
  script:
    - docker pull $CI_REGISTRY_IMAGE:latest-arm64 || true
    - docker build --target fpm --cache-from $CI_REGISTRY_IMAGE:latest-arm64 --tag $CI_REGISTRY_IMAGE:$VERSION-arm64 --tag $CI_REGISTRY_IMAGE:latest-arm64 .
    - docker push $CI_REGISTRY_IMAGE:$VERSION-arm64
    - docker push $CI_REGISTRY_IMAGE:latest-arm64

amd64:
  stage: build
  tags:
    - "saas-linux-small-amd64"
  only:
    - main
  script:
    - docker pull $CI_REGISTRY_IMAGE:latest-amd64 || true
    - docker build --target fpm --cache-from $CI_REGISTRY_IMAGE:latest-amd64 --tag $CI_REGISTRY_IMAGE:$VERSION-amd64 --tag $CI_REGISTRY_IMAGE:latest-amd64 .
    - docker push $CI_REGISTRY_IMAGE:$VERSION-amd64
    - docker push $CI_REGISTRY_IMAGE:latest-amd64

newrelic_arm64:
  stage: build
  tags:
    - "[arm64]"
  only:
    - main
  script:
    - docker pull $CI_REGISTRY_IMAGE:latest-newrelic-arm64 || true
    - docker build --target fpm_newrelic --cache-from $CI_REGISTRY_IMAGE:latest-newrelic-arm64 --tag $CI_REGISTRY_IMAGE:$VERSION-newrelic-arm64 --tag $CI_REGISTRY_IMAGE:latest-newrelic-arm64 .
    - docker push $CI_REGISTRY_IMAGE:$VERSION-newrelic-arm64
    - docker push $CI_REGISTRY_IMAGE:latest-newrelic-arm64

newrelic_amd64:
  stage: build
  tags:
    - "saas-linux-small-amd64"
  only:
    - main
  script:
    - docker pull $CI_REGISTRY_IMAGE:latest-newrelic-amd64 || true
    - docker build --target fpm_newrelic --cache-from $CI_REGISTRY_IMAGE:latest-newrelic-amd64 --tag $CI_REGISTRY_IMAGE:$VERSION-newrelic-amd64 --tag $CI_REGISTRY_IMAGE:latest-newrelic-amd64 .
    - docker push $CI_REGISTRY_IMAGE:$VERSION-newrelic-amd64
    - docker push $CI_REGISTRY_IMAGE:latest-newrelic-amd64